diff --git a/theme/bootstrapbase/lang/en/theme_bootstrapbase.php b/theme/bootstrapbase/lang/en/theme_bootstrapbase.php
index daa40e1..784091b 100644
--- a/theme/bootstrapbase/lang/en/theme_bootstrapbase.php
+++ b/theme/bootstrapbase/lang/en/theme_bootstrapbase.php
@@ -22,6 +22,8 @@
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
 
+$string['pinnavbar_in'] = 'Un-pin the navbar from the top of the screen.';
+$string['pinnavbar_out'] = 'Pin the navbar to the top of the screen. It will scroll with you.';
 $string['pluginname'] = 'Bootstrap Base';
 $string['region-side-post'] = 'Right';
 $string['region-side-pre'] = 'Left';
diff --git a/theme/bootstrapbase/layout/columns1.php b/theme/bootstrapbase/layout/columns1.php
index a95a14c..234f3e7 100644
--- a/theme/bootstrapbase/layout/columns1.php
+++ b/theme/bootstrapbase/layout/columns1.php
@@ -48,7 +48,7 @@ echo $OUTPUT->doctype() ?>
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
                     <li><?php echo $OUTPUT->page_heading_menu(); ?></li>
-                    <li class="navbar-text"><?php echo $OUTPUT->login_info() ?></li>
+                    <li class="navbar-text"><?php echo $OUTPUT->navbar_pin(); ?><?php echo $OUTPUT->login_info() ?></li>
                 </ul>
             </div>
         </div>
diff --git a/theme/bootstrapbase/layout/columns2.php b/theme/bootstrapbase/layout/columns2.php
index 738dbda..7b2bdfd 100644
--- a/theme/bootstrapbase/layout/columns2.php
+++ b/theme/bootstrapbase/layout/columns2.php
@@ -49,7 +49,7 @@ echo $OUTPUT->doctype() ?>
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
                     <li><?php echo $OUTPUT->page_heading_menu(); ?></li>
-                    <li class="navbar-text"><?php echo $OUTPUT->login_info() ?></li>
+                    <li class="navbar-text"><?php echo $OUTPUT->navbar_pin(); ?><?php echo $OUTPUT->login_info() ?></li>
                 </ul>
             </div>
         </div>
diff --git a/theme/bootstrapbase/layout/columns3.php b/theme/bootstrapbase/layout/columns3.php
index d02bd69..29ce52b 100644
--- a/theme/bootstrapbase/layout/columns3.php
+++ b/theme/bootstrapbase/layout/columns3.php
@@ -54,7 +54,7 @@ echo $OUTPUT->doctype() ?>
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
                     <li><?php echo $OUTPUT->page_heading_menu(); ?></li>
-                    <li class="navbar-text"><?php echo $OUTPUT->login_info() ?></li>
+                    <li class="navbar-text"><?php echo $OUTPUT->navbar_pin(); ?><?php echo $OUTPUT->login_info() ?></li>
                 </ul>
             </div>
         </div>
diff --git a/theme/bootstrapbase/renderers/core_renderer.php b/theme/bootstrapbase/renderers/core_renderer.php
index fffbdb4..66f31fd 100644
--- a/theme/bootstrapbase/renderers/core_renderer.php
+++ b/theme/bootstrapbase/renderers/core_renderer.php
@@ -220,4 +220,34 @@ class theme_bootstrapbase_core_renderer extends core_renderer {
             return html_writer::tag('li', $link);
         }
     }
+
+    /**
+     * Produces a pin for the navbar and adds JS to toggle the navbar between fixed and static.
+     *
+     * @return string
+     */
+    public function navbar_pin($navbarclass = 'navbar') {
+        $userpreference = 'theme_bootstrapbase_navbarpin';
+
+        $this->page->requires->yui_module(
+            'moodle-theme_bootstrapbase-navbarpin',
+            'Y.Moodle.theme_bootstrapbase.navbarpin.init',
+            array(
+                'userpreference' => $userpreference,
+                'navbarclass' => $navbarclass
+            )
+        );
+        user_preference_allow_ajax_update($userpreference, PARAM_BOOL);
+        $set = get_user_preferences($userpreference, false);
+        if ($set) {
+            $alt = get_string('pinnavbar_in', 'theme_bootstrapbase');
+            $class = ' pin-in';
+        } else {
+            $alt = get_string('pinnavbar_out', 'theme_bootstrapbase');
+            $class = ' pin-out';
+        }
+        $icon = new pix_icon('pin', $alt, 'theme_bootstrapbase');
+        $attrs = array('id' => 'pin-navbar-button', 'role' => 'button', 'class' => 'btn'.$class);
+        return html_writer::link('#', $this->render($icon), $attrs);
+    }
 }
diff --git a/theme/bootstrapbase/yui/build/moodle-theme_bootstrapbase-navbarpin/moodle-theme_bootstrapbase-navbarpin-debug.js b/theme/bootstrapbase/yui/build/moodle-theme_bootstrapbase-navbarpin/moodle-theme_bootstrapbase-navbarpin-debug.js
new file mode 100644
index 0000000..1540f55
--- /dev/null
+++ b/theme/bootstrapbase/yui/build/moodle-theme_bootstrapbase-navbarpin/moodle-theme_bootstrapbase-navbarpin-debug.js
@@ -0,0 +1,51 @@
+YUI.add('moodle-theme_bootstrapbase-navbarpin', function (Y, NAME) {
+
+var NS = Y.namespace('Moodle.theme_bootstrapbase.navbarpin'),
+    CSS = {
+        NAVBAR : '.navbar',
+        NAVBARPINNED : 'navbar-pinned',
+        PIN : '#pin-navbar-button',
+        PININ : 'pin-in',
+        PINOUT : 'pin-out'
+    };
+
+NS.navbar = null;
+NS.pin = null;
+NS.currentlypinned = false;
+NS.userpreference = 'theme_bootstrapbase_navbarpin';
+
+NS.init = function(args) {
+    if (args.userpreference) {
+        this.userpreference = args.userpreference;
+    }
+    var body = Y.one('body');
+    this.pin = Y.one(CSS.PIN);
+    this.navbar = this.pin.ancestor((args.navbarclass) ? '.' + args.navbarclass : CSS.NAVBAR);
+    if (!this.pin || !this.navbar) {
+        Y.log('Unable to locate either the navbar or a pin for it.', 'warn', 'moodle-theme_bootstrapbase-navbarpin');
+        return false;
+    }
+    this.currentlypinned = this.pin.hasClass(CSS.PININ);
+    if (this.currentlypinned && !body.hasClass('.'+CSS.NAVBARPINNED)) {
+        body.addClass(CSS.NAVBARPINNED);
+    }
+    this.pin.on('click', this.togglePin, this);
+};
+
+NS.togglePin = function(e) {
+    e.preventDefault();
+    var body = Y.one('body');
+    if (this.currentlypinned) {
+        this.pin.replaceClass(CSS.PININ, CSS.PINOUT);
+        body.removeClass(CSS.NAVBARPINNED);
+        this.currentlypinned = false;
+    } else {
+        this.pin.replaceClass(CSS.PINOUT, CSS.PININ);
+        body.addClass(CSS.NAVBARPINNED);
+        this.currentlypinned = true;
+    }
+    M.util.set_user_preference(this.userpreference, this.currentlypinned);
+};
+
+
+}, '@VERSION@', {"requires": ["node", "event"]});
diff --git a/theme/bootstrapbase/yui/build/moodle-theme_bootstrapbase-navbarpin/moodle-theme_bootstrapbase-navbarpin.js b/theme/bootstrapbase/yui/build/moodle-theme_bootstrapbase-navbarpin/moodle-theme_bootstrapbase-navbarpin.js
new file mode 100644
index 0000000..058c691
--- /dev/null
+++ b/theme/bootstrapbase/yui/build/moodle-theme_bootstrapbase-navbarpin/moodle-theme_bootstrapbase-navbarpin.js
@@ -0,0 +1,50 @@
+YUI.add('moodle-theme_bootstrapbase-navbarpin', function (Y, NAME) {
+
+var NS = Y.namespace('Moodle.theme_bootstrapbase.navbarpin'),
+    CSS = {
+        NAVBAR : '.navbar',
+        NAVBARPINNED : 'navbar-pinned',
+        PIN : '#pin-navbar-button',
+        PININ : 'pin-in',
+        PINOUT : 'pin-out'
+    };
+
+NS.navbar = null;
+NS.pin = null;
+NS.currentlypinned = false;
+NS.userpreference = 'theme_bootstrapbase_navbarpin';
+
+NS.init = function(args) {
+    if (args.userpreference) {
+        this.userpreference = args.userpreference;
+    }
+    var body = Y.one('body');
+    this.pin = Y.one(CSS.PIN);
+    this.navbar = this.pin.ancestor((args.navbarclass) ? '.' + args.navbarclass : CSS.NAVBAR);
+    if (!this.pin || !this.navbar) {
+        return false;
+    }
+    this.currentlypinned = this.pin.hasClass(CSS.PININ);
+    if (this.currentlypinned && !body.hasClass('.'+CSS.NAVBARPINNED)) {
+        body.addClass(CSS.NAVBARPINNED);
+    }
+    this.pin.on('click', this.togglePin, this);
+};
+
+NS.togglePin = function(e) {
+    e.preventDefault();
+    var body = Y.one('body');
+    if (this.currentlypinned) {
+        this.pin.replaceClass(CSS.PININ, CSS.PINOUT);
+        body.removeClass(CSS.NAVBARPINNED);
+        this.currentlypinned = false;
+    } else {
+        this.pin.replaceClass(CSS.PINOUT, CSS.PININ);
+        body.addClass(CSS.NAVBARPINNED);
+        this.currentlypinned = true;
+    }
+    M.util.set_user_preference(this.userpreference, this.currentlypinned);
+};
+
+
+}, '@VERSION@', {"requires": ["node", "event"]});
diff --git a/theme/bootstrapbase/yui/src/navbarpin/js/navbarpin.js b/theme/bootstrapbase/yui/src/navbarpin/js/navbarpin.js
new file mode 100644
index 0000000..6e37c82
--- /dev/null
+++ b/theme/bootstrapbase/yui/src/navbarpin/js/navbarpin.js
@@ -0,0 +1,46 @@
+var NS = Y.namespace('Moodle.theme_bootstrapbase.navbarpin'),
+    CSS = {
+        NAVBAR : '.navbar',
+        NAVBARPINNED : 'navbar-pinned',
+        PIN : '#pin-navbar-button',
+        PININ : 'pin-in',
+        PINOUT : 'pin-out'
+    };
+
+NS.navbar = null;
+NS.pin = null;
+NS.currentlypinned = false;
+NS.userpreference = 'theme_bootstrapbase_navbarpin';
+
+NS.init = function(args) {
+    if (args.userpreference) {
+        this.userpreference = args.userpreference;
+    }
+    var body = Y.one('body');
+    this.pin = Y.one(CSS.PIN);
+    this.navbar = this.pin.ancestor((args.navbarclass) ? '.' + args.navbarclass : CSS.NAVBAR);
+    if (!this.pin || !this.navbar) {
+        Y.log('Unable to locate either the navbar or a pin for it.', 'warn', 'moodle-theme_bootstrapbase-navbarpin');
+        return false;
+    }
+    this.currentlypinned = this.pin.hasClass(CSS.PININ);
+    if (this.currentlypinned && !body.hasClass('.'+CSS.NAVBARPINNED)) {
+        body.addClass(CSS.NAVBARPINNED);
+    }
+    this.pin.on('click', this.togglePin, this);
+};
+
+NS.togglePin = function(e) {
+    e.preventDefault();
+    var body = Y.one('body');
+    if (this.currentlypinned) {
+        this.pin.replaceClass(CSS.PININ, CSS.PINOUT);
+        body.removeClass(CSS.NAVBARPINNED);
+        this.currentlypinned = false;
+    } else {
+        this.pin.replaceClass(CSS.PINOUT, CSS.PININ);
+        body.addClass(CSS.NAVBARPINNED);
+        this.currentlypinned = true;
+    }
+    M.util.set_user_preference(this.userpreference, this.currentlypinned);
+};
diff --git a/theme/clean/layout/columns1.php b/theme/clean/layout/columns1.php
index 61e6248..17e1201 100644
--- a/theme/clean/layout/columns1.php
+++ b/theme/clean/layout/columns1.php
@@ -51,7 +51,7 @@ echo $OUTPUT->doctype() ?>
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
                     <li><?php echo $OUTPUT->page_heading_menu(); ?></li>
-                    <li class="navbar-text"><?php echo $OUTPUT->login_info() ?></li>
+                    <li class="navbar-text"><?php echo $OUTPUT->navbar_pin(); ?><?php echo $OUTPUT->login_info() ?></li>
                 </ul>
             </div>
         </div>
diff --git a/theme/clean/layout/columns2.php b/theme/clean/layout/columns2.php
index b5e8e23..76944ec 100644
--- a/theme/clean/layout/columns2.php
+++ b/theme/clean/layout/columns2.php
@@ -52,7 +52,7 @@ echo $OUTPUT->doctype() ?>
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
                     <li><?php echo $OUTPUT->page_heading_menu(); ?></li>
-                    <li class="navbar-text"><?php echo $OUTPUT->login_info() ?></li>
+                    <li class="navbar-text"><?php echo $OUTPUT->navbar_pin(); ?><?php echo $OUTPUT->login_info() ?></li>
                 </ul>
             </div>
         </div>
diff --git a/theme/clean/layout/columns3.php b/theme/clean/layout/columns3.php
index ccc21bc..e4d2d69 100644
--- a/theme/clean/layout/columns3.php
+++ b/theme/clean/layout/columns3.php
@@ -63,7 +63,7 @@ echo $OUTPUT->doctype() ?>
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
                     <li><?php echo $OUTPUT->page_heading_menu(); ?></li>
-                    <li class="navbar-text"><?php echo $OUTPUT->login_info() ?></li>
+                    <li class="navbar-text"><?php echo $OUTPUT->navbar_pin(); ?><?php echo $OUTPUT->login_info() ?></li>
                 </ul>
             </div>
         </div>
